part of katana_theme_builder;

List<Spec> extension(List<AssetNode> nodes, AssetConfig config) {
  return [
    if (nodes.isNotEmpty) ...[
      Extension(
        (e) => e
          ..name = r"$ThemeAssetsExtensions"
          ..on = const Reference("AssetThemeData")
          ..methods.addAll([
            ...nodes.map((node) {
              return Method(
                (m) => m
                  ..name = node.name
                  ..type = MethodType.getter
                  ..lambda = true
                  ..returns = Reference("_\$${node.path.toSHA1()}")
                  ..body = Code("const _\$${node.path.toSHA1()}()"),
              );
            })
          ]),
      ),
      ...nodes.expand((node) {
        return node.toSpec(config);
      })
    ],
  ];
}
